#include "sprox_desfire_i.h"

static WORD UpdateCrc(BYTE ch, WORD * lpwCrc)
{
  ch = (ch ^ (BYTE) ((*lpwCrc) & 0x00FF));
  ch = (ch ^ (ch << 4));
  *lpwCrc = (*lpwCrc >> 8) ^ ((WORD) ch << 8) ^ ((WORD) ch << 3) ^ ((WORD) ch >> 4);
  return (*lpwCrc);
}

WORD ComputeIso14443ACrc(BYTE crc[2], const BYTE buffer[], WORD size)
{
  BYTE  chBlock;
  WORD  wCrc;
  BYTE *p = (BYTE *) buffer;
  
  wCrc = 0x6363;                /* ITU-V.41 */

  do
  {
    chBlock = *p++;
    UpdateCrc(chBlock, &wCrc);
  } while (--size);

  if (crc != NULL)
  {
    crc[0] = (BYTE) (wCrc & 0xFF);
    crc[1] = (BYTE) ((wCrc >> 8) & 0xFF);
  }

  return wCrc;
}
