// SproxTest2Dlg.cpp : implementation file
//

#include "StdAfx.h"
#include "SproxTest.h"
#include "SproxTestDlg.h"
#include "hardware\springprox\springprox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAX_SECTORS   40
#define MAX_BYTES     256

/////////////////////////////////////////////////////////////////////////////
// CSproxTest2Dlg dialog

CSproxTest2Dlg::CSproxTest2Dlg(CWnd * pParent /*=NULL*/ )
:CDialog(CSproxTest2Dlg::IDD, pParent)
{
  //{{AFX_DATA_INIT(CSproxTest2Dlg)
  m_ad = _T("");
  m_ats = _T("");
  m_snr = _T("");
  m_tt = _T("");
  m_com = _T("");
  m_devsnr = _T("");
  m_devtype = _T("");
  m_firmware = _T("");
  m_library = _T("");
  m_list = _T("");
  m_mess = _T("");
  m_rc = _T("");
  m_val = _T("");
  m_numsect = _T("");
  //}}AFX_DATA_INIT
  // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
  m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSproxTest2Dlg::DoDataExchange(CDataExchange * pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(CSproxTest2Dlg)
  DDX_Control(pDX, IDC_NUMSECT, m_control_numsect);
  DDX_Control(pDX, IDC_VAL, m_control_val);
  DDX_Control(pDX, IDC_LIST, m_control_list);
  DDX_Control(pDX, IDC_AD, m_control_ad);
  DDX_Text(pDX, IDC_AD, m_ad);
  DDX_Text(pDX, IDC_BADGEATS, m_ats);
  DDX_Text(pDX, IDC_BADGESNR, m_snr);
  DDX_Text(pDX, IDC_BADGETT, m_tt);
  DDX_Text(pDX, IDC_COM, m_com);
  DDX_Text(pDX, IDC_DEVSNR, m_devsnr);
  DDX_Text(pDX, IDC_DEVTYPE, m_devtype);
  DDX_Text(pDX, IDC_FIRMWARE, m_firmware);
  DDX_Text(pDX, IDC_LIBRARY, m_library);
  DDX_LBString(pDX, IDC_LIST, m_list);
  DDX_Text(pDX, IDC_MESS, m_mess);
  DDX_Text(pDX, IDC_RC, m_rc);
  DDX_Text(pDX, IDC_VAL, m_val);
  DDX_LBString(pDX, IDC_NUMSECT, m_numsect);
  //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSproxTest2Dlg, CDialog)
  //{{AFX_MSG_MAP(CSproxTest2Dlg)
  ON_BN_CLICKED(IDC_OPEN, OnOpen)
ON_BN_CLICKED(IDC_LOAD_KEY, OnLoadKey)
ON_BN_CLICKED(IDC_WRITE_READER, OnWriteReader)
ON_BN_CLICKED(IDC_READ_READER, OnReadReader)
ON_BN_CLICKED(IDC_WAIT_CARD, OnWaitCard)
ON_BN_CLICKED(IDC_READBADGE, OnReadbadge)
ON_BN_CLICKED(IDC_WRITEBADGE, OnWritebadge)
ON_WM_TIMER()ON_BN_CLICKED(IDC_TILDE, OnTilde)
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CSproxTest2Dlg message handlers
     BOOL CSproxTest2Dlg::OnInitDialog()
{
  CDialog::OnInitDialog();

  // Set the icon for this dialog.  The framework does this automatically
  //  when the application's main window is not a dialog
  SetIcon(m_hIcon, TRUE);       // Set big icon
  SetIcon(m_hIcon, FALSE);      // Set small icon

  CenterWindow(GetDesktopWindow()); // center to the hpc screen

  // TODO: Add extra initialization here
  int i = 0;
  TCHAR temp[3];

  for (i = 0; i < MAX_SECTORS; i++)
  {
    if (i < 10)
      swprintf(temp, _T("0%d"), i);
    else
      swprintf(temp, _T("%d"), i);
    m_control_numsect.AddString(temp);
  }
  return TRUE;                  // return TRUE  unless you set the focus to a control
}

/////////////////////////////////////////////////////////////////////////////
//

extern BYTE SPROX_LEVEL;

WORD SWAP_WORD(WORD w)
{
  BYTE h, l;

  h = (BYTE) (w / 0x0100);
  l = (BYTE) (w % 0x0100);
  return (l * 0x0100 + h);
}

#define KEY_COUNT 5
static BYTE DEFAULT_KEYS[2 * KEY_COUNT * 6] = {
//  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, /* A.0 -> AAAAAA */

  0xA0, 0xA1, 0xA2, 0xA3, 0xA4, 0xA5, /* A.0 -> AAAAAA */
  0x31, 0x4B, 0x49, 0x47, 0x49, 0x56, /* A.1 -> VIGIK1 */
  0x41, 0x43, 0x41, 0x4F, 0x52, 0x50, /* A.2 -> PROACA */
  0x41, 0x4C, 0x41, 0x52, 0x4F, 0x4E, /* A.3 -> NORALA */
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, /* B.3 -> FFFFFF */

  0x42, 0x43, 0x41, 0x4F, 0x52, 0x50, /* B.0 -> PROACB */
  0x42, 0x4C, 0x41, 0x52, 0x4F, 0x4E, /* B.1 -> NORALB */
  0xB0, 0xB1, 0xB2, 0xB3, 0xB4, 0xB5, /* B.2 -> BBBBBB */
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, /* B.3 -> FFFFFF */
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, /* B.3 -> FFFFFF */
};

static BYTE sectData[MAX_BYTES];

BYTE new_key_A[6] = { 0xA0, 0xA1, 0xA2, 0xA3, 0xA4, 0xA5 };
BYTE new_key_B[6] = { 0xB0, 0xB1, 0xB2, 0xB3, 0xB4, 0xB5 };
BYTE demo_key_A[6] = { 'D', 'E', 'M', 'O', '_', 'A' };
BYTE demo_key_B[6] = { 'D', 'E', 'M', 'O', '_', 'B' };
BYTE transport_key[6] = { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };


BOOL DefaultKeysToE2(void)
{
  SWORD rc;
  BYTE i;

  for (i = 0; i < KEY_COUNT; i++)
  {
#ifdef lowerUG
    printf("Mf500PcdLoadKeyE2 (A%d) ", i);
#endif
    rc = Mf500PcdLoadKeyE2(PICC_AUTHENT1A, i, &DEFAULT_KEYS[6 * i]);
#ifdef lowerUG
    printf("rc=%d\n", rc);
#endif
    if (rc != MI_OK)
      return FALSE;
  }
  for (i = 0; i < KEY_COUNT; i++)
  {
#ifdef lowerUG
    printf("Mf500PcdLoadKeyE2 (B%d) ", i);
#endif
    rc =
      Mf500PcdLoadKeyE2(PICC_AUTHENT1B, i,
                        &DEFAULT_KEYS[6 * (i + KEY_COUNT)]);
#ifdef lowerUG
    printf("rc=%d\n", rc);
#endif
    if (rc != MI_OK)
      return FALSE;
  }
  return TRUE;
}


///////////////////////////////////////////////////////////////////////////////////////////
#define OK 1
#define NOTOK -1
#define WRONGVALUE -4
#define MYTIMER 1

BYTE getHexQ(char q);
BYTE hexa(TCHAR * tab);

int searchFlag = 0;
int z = 0;
SWORD wrc = 0;

/////////////////////////////////////////////////////////////////////////////
//My function


BYTE getHexQ(TCHAR q)
{
  BYTE v = 0;

  if ((q >= '0') && (q <= '9'))
    v = q - '0';
  else if ((q >= 'a') && (q <= 'f'))
    v = q - 'a' + 10;
  else if ((q >= 'A') && (q <= 'F'))
    v = q - 'A' + 10;
  else
    v = 0;
  return v;
}


BYTE hexa(TCHAR * tab)
{
  BYTE part[2];
  BYTE total = 0;

  part[0] = getHexQ(tab[0]);
  part[1] = getHexQ(tab[1]);
  total = part[0] * 16 + part[1];
  return total;
}

/////////////////////////////////////////////////////////////////////////////



BYTE snr[12];
BYTE tt[2];
BYTE ats;

#define CLOSED 0
#define IDLE   1
#define ACTIVE 2

BYTE reader_status = CLOSED;

/*-----------------------------------------------------------------*/

void CSproxTest2Dlg::OnOpen()
{
  SWORD rc;
  SWORD err = 0;
  TCHAR firmware[20];
  BYTE dev_type[5], dev_snr[4];
  TCHAR library[100];
  TCHAR mess[50];
  TCHAR com[20];

  CWaitCursor patient;

  z = 0;

  /* Close if already opened */
  if (reader_status != CLOSED)
  {
    m_com = "";
    m_mess = "";
    m_firmware = "";
    m_devtype = "";
    m_devsnr = "";
    m_library = "";
    m_rc = "Closing reader";
    rc = SPROX_ReaderClose();
    swprintf(mess, _T("SPROX_ReaderClose() rc=%d"), rc);
    reader_status = CLOSED;
    UpdateData(FALSE);

    /* Stop here */
    return;
  }


  /* Get Library : SpringProx.dll */
  rc = SPROX_GetLibrary(library, sizeof(library) / 2);
  m_rc = "Getting library";
  UpdateData(FALSE);
  if (rc != MI_OK)
  {
    m_library = "Getting library failed !";
    m_mess = CString(SPROX_GetErrorMessage(rc));
    UpdateData(FALSE);
    return;
  }

  m_library = library;
  m_mess = CString(SPROX_GetErrorMessage(rc));
  UpdateData(FALSE);

  rc = SPROX_ReaderOpen(NULL);
  if (rc != MI_OK)
  {
    m_mess = CString(SPROX_GetErrorMessage(rc));
    m_rc = "Opening the reader";
    UpdateData(FALSE);
    return;
  }

  reader_status = ACTIVE;
  m_com = "OK";
  m_mess = CString(SPROX_GetErrorMessage(rc));
  UpdateData(FALSE);

  /* Com port ok */
  rc = SPROX_ReaderGetDevice(com, sizeof(com));
  if (rc == MI_OK)
  {
    swprintf(mess, _T("%s"), com);
    m_com = mess;
    UpdateData(FALSE);
  }

  /* Firmware ? */
  rc = SPROX_ReaderGetFirmware(firmware, sizeof(firmware));
  m_rc = "Firmware version";
  UpdateData(FALSE);
  if (rc != MI_OK)
  {
    m_firmware = "Getting firmware failed !";
    m_mess = CString(SPROX_GetErrorMessage(rc));
    UpdateData(FALSE);
  } else
  {
    /* Firmware is : */
    m_firmware = firmware;
    m_mess = CString(SPROX_GetErrorMessage(rc));
  }

  /* Device ? */
  rc = SPROX_ReaderGetRc500Id(dev_type, dev_snr);
  m_rc = "dev type and SNR";
  UpdateData(FALSE);
  if (rc != MI_OK)
  {
    m_devtype = "Getting type failed !";
    m_devsnr = "Getting serial failed !";
    m_mess = CString(SPROX_GetErrorMessage(rc));
    UpdateData(FALSE);
  } else
  {
    /* Device is : */
    swprintf(mess, _T("%02X%02X%02X%02X%02X"), dev_type[0], dev_type[1],
             dev_type[2], dev_type[3], dev_type[4], dev_type[5]);
    m_devtype = mess;
    swprintf(mess, _T("%02X%02X%02X%02X"), dev_snr[0], dev_snr[1], dev_snr[2],
             dev_snr[3]);
    m_devsnr = mess;
  }

  patient.Restore();
  UpdateData(FALSE);
}

/*-----------------------------------------------------------------*/
void CSproxTest2Dlg::OnLoadKey()
{
  m_rc = "Loading keys";
  UpdateData(FALSE);

  if (DefaultKeysToE2() == TRUE)
  {
    m_mess = "Loading keys successful";
    UpdateData(FALSE);
  } else
  {
    m_mess = "Loading keys failed";
    UpdateData(FALSE);
  }
}

/*-----------------------------------------------------------------*/
void CSproxTest2Dlg::OnWriteReader()
{
  BYTE value;
  BYTE address;
  SWORD rc;
  TCHAR text[20];

  m_rc = "Writing in device";
  //recuperer l'adresse entree
  m_control_ad.GetLine(0, text);
  address = hexa(text);

  //recuperer la valeur a ecrire
  m_control_val.GetLine(0, text);
  value = hexa(text);

  //ecrire dans le reader
  rc = WriteRIC(address, value);

  if (rc == MI_OK)
  {
    swprintf(text, _T("%02X"), address);
    m_ad = CString(text);
    m_control_val.GetLine(0, text);
    value = hexa(text);
    swprintf(text, _T("%02X"), value);
    m_val = CString(text);
  } else
  {
    m_mess = "Writing error in device";
  }

  UpdateData(FALSE);
}

/*-----------------------------------------------------------------*/
void CSproxTest2Dlg::OnReadReader()
{
  BYTE value;
  BYTE address;
  SWORD rc;
  TCHAR text[20];

  m_rc = "Reading in device";
  //recuperer l'adresse entree
  m_control_ad.GetLine(0, text);
  address = hexa(text);

  //ecrire dans le reader
  rc = ReadRIC(address, &value);
  if (rc == MI_OK)
  {
    swprintf(text, _T("%02X"), value);
    m_val = CString(text);
    swprintf(text, _T("%02X"), address);
    m_ad = CString(text);
  } else
  {
    m_mess = CString(SPROX_GetErrorMessage(rc));
  }

  UpdateData(FALSE);
}

/*-----------------------------------------------------------------*/
void CSproxTest2Dlg::OnWaitCard()
{
  z = 0;
  m_snr = "";
  m_tt = "";
  m_ats = "";
  m_mess = "";

  m_rc = "Waiting for a card";
  UpdateData(FALSE);

  m_control_list.ResetContent();

  if (reader_status == CLOSED)
  {
    OnOpen();
  } else if (reader_status == IDLE)
  {
    OnTilde();
  }

  CWaitCursor patient;

  SetTimer(MYTIMER, 200, NULL);

}

/*-----------------------------------------------------------------*/

void CSproxTest2Dlg::OnWritebadge()
{
  SWORD rc;
  TCHAR tmp[30];
  BYTE numsect = 0;

  if (MessageBox
      (_T("Are you sure you want to update the sector with current data ?"),
       _T("Write sector"), MB_OKCANCEL | MB_ICONWARNING) != IDOK)
    return;

  if (((numsect = m_control_numsect.GetCurSel()) < 0)
      || numsect > MAX_SECTORS)
  {
    numsect = 0;
  }

  m_rc = "Write sector";
  UpdateData(FALSE);
  {
    CWaitCursor patient;

    rc = SPROX_MifStWriteSector(snr, numsect, sectData, NULL);  // use default keys in EEPROM
    if (rc != MI_OK)
      rc = SPROX_MifStWriteSector(snr, numsect, sectData, demo_key_A);
    if (rc != MI_OK)
      rc = SPROX_MifStWriteSector(snr, numsect, sectData, demo_key_B);
    if (rc != MI_OK)
      rc = SPROX_MifStWriteSector(snr, numsect, sectData, new_key_A);
    if (rc != MI_OK)
      rc = SPROX_MifStWriteSector(snr, numsect, sectData, new_key_B);
  }
  if (rc != MI_OK)
  {
    m_mess = SPROX_GetErrorMessage(rc);
    swprintf(tmp, _T("Writing error on sector %d"), numsect);
    UpdateData(FALSE);
  } else
  {
    m_mess = SPROX_GetErrorMessage(rc);
  }
  UpdateData(FALSE);
}

void CSproxTest2Dlg::OnReadbadge()
{
  SWORD rc;
  BYTE numsect = 0;
  TCHAR tmp[30];
  BYTE block = 0;
  BYTE max_block = 3;
  BYTE m = 0, p = 0;

  memset(sectData, 0xaa, MAX_BYTES);

  m_control_list.ResetContent();
  m = m_control_list.GetCount();
  for (p = 0; p < m; p++)
  {
    m_control_list.DeleteString(p);
  }
  m_control_list.Invalidate(TRUE);
  UpdateWindow();

  //OnWaitCard();

  if (((numsect = m_control_numsect.GetCurSel()) < 0)
      || numsect > MAX_SECTORS)
  {
    numsect = 0;
  }

  m_rc = "Read sector";
  UpdateData(FALSE);
  {
    CWaitCursor patient;

    rc = SPROX_MifStReadSector(snr, numsect, sectData, NULL); // use default keys in EEPROM
    if (rc != MI_OK)
      rc = SPROX_MifStReadSector(snr, numsect, sectData, demo_key_A);
    if (rc != MI_OK)
      rc = SPROX_MifStReadSector(snr, numsect, sectData, demo_key_B);
    if (rc != MI_OK)
      rc = SPROX_MifStReadSector(snr, numsect, sectData, new_key_A);
    if (rc != MI_OK)
      rc = SPROX_MifStReadSector(snr, numsect, sectData, new_key_B);
  }
  if (rc != MI_OK)
  {
    m_mess = SPROX_GetErrorMessage(rc);
    swprintf(tmp, _T("Reading error on sector %d"), numsect);
    //m_mess = tmp;
    m_control_list.ResetContent();
    m_snr = "";
    m_tt = "";
    m_ats = "";
    UpdateData(FALSE);
  } else
  {
    m_mess = SPROX_GetErrorMessage(rc);
    {
      BYTE tmp2[66];
      BYTE i = 0, j = 0;
      BYTE l = 0;

      memset(tmp2, 0x00, sizeof(tmp2));
      l = 0;
      i = 0;

      for (block = 0; block < max_block; block++)
      {
        swprintf((TCHAR *) tmp2,
                 _T
                 ("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X"),
                 sectData[i + 15], sectData[i + 14], sectData[i + 13],
                 sectData[i + 12], sectData[i + 11], sectData[i + 10],
                 sectData[i + 9], sectData[i + 8], sectData[i + 7],
                 sectData[i + 6], sectData[i + 5], sectData[i + 4],
                 sectData[i + 3], sectData[i + 2], sectData[i + 1],
                 sectData[i]);
        i += 16;
        m_control_list.InsertString(l, (TCHAR *) (tmp2));
        l++;
      }
    }
  }
  UpdateData(FALSE);
}


/*-----------------------------------------------------------------*/
void CSproxTest2Dlg::OnOK()
{
  SWORD rc = 0;
  TCHAR text[40];

  // close the communication
  m_mess = "SpringProx : deconnexion...\n";
  UpdateData(FALSE);

  rc = SPROX_ReaderClose();
  swprintf(text, _T("SPROX_ReaderClose() rc=%d"), rc);
  m_mess = text;

  UpdateData(FALSE);
  KillTimer(MYTIMER);

  CDialog::OnOK();
}


/*-----------------------------------------------------------------*/
void CSproxTest2Dlg::OnTimer(UINT nIDEvent)
{
  TCHAR tmp[30];
  BYTE snrlen;

  wrc = SPROX_MifStSelectAny(snr, tt, &ats);
  if (wrc == MI_OK)
  {
    searchFlag = 1;

    snrlen = 4;
    if ((tt[0] & 0xC0) == 0x40)
      snrlen = 7;
    if ((tt[0] & 0xC0) == 0x80)
      snrlen = 10;

    if (snrlen == 4)
      swprintf(tmp, _T("%02X%02X%02X%02X"), snr[3], snr[2], snr[1], snr[0]);
    if (snrlen == 7)
      swprintf(tmp, _T("%02X%02X%02X%02X%02X%02X%02X"), snr[6], snr[5],
               snr[4], snr[3], snr[2], snr[1], snr[0]);
    if (snrlen == 10)
      swprintf(tmp, _T("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X"), snr[9],
               snr[8], snr[7], snr[6], snr[5], snr[4], snr[3], snr[2], snr[1],
               snr[0]);

    m_snr = tmp;

    swprintf(tmp, _T("%02X%02X"), tt[1], tt[0]);
    m_tt = tmp;
    swprintf(tmp, _T("%02X"), ats);
    m_ats = tmp;
    swprintf(tmp, _T("%d"), wrc);
    m_mess = CString(SPROX_GetErrorMessage(wrc));
    UpdateData(FALSE);
    KillTimer(MYTIMER);
    z = 0;
    return;
  } else
  {
    searchFlag = 0;
    m_snr = "";
    m_tt = "";
    m_ats = "";
  }
  z++;

  if (z > 10)
  {
    searchFlag = 1;
    m_mess = CString(SPROX_GetErrorMessage(wrc));
    z = 0;
    KillTimer(MYTIMER);
  }

  UpdateData(FALSE);
  CDialog::OnTimer(nIDEvent);
}

void CSproxTest2Dlg::OnTilde()
{
  TCHAR mess[50];
  SWORD rc;

  /* Deactivate */
  if (reader_status == ACTIVE)
  {
    m_rc = "Deactivating reader";
    rc = SPROX_ReaderDeactivate();
    swprintf(mess, _T("SPROX_ReaderDeactivate() rc=%d"), rc);
    UpdateData(FALSE);
    if (rc == MI_OK)
    {
      reader_status = IDLE;
    }

    /* Stop here */
    return;
  }

  if (reader_status == IDLE)
  {
    m_rc = "Activating reader";
    rc = SPROX_ReaderActivate();
    swprintf(mess, _T("SPROX_ReaderActivate() rc=%d"), rc);
    UpdateData(FALSE);
    if (rc == MI_OK)
    {
      reader_status = ACTIVE;
    } else
    {
      m_com = "";
      m_mess = "";
      m_firmware = "";
      m_devtype = "";
      m_devsnr = "";
      m_library = "";
      m_rc = "Closing reader";
      rc = SPROX_ReaderClose();
      swprintf(mess, _T("SPROX_ReaderClose() rc=%d"), rc);
      UpdateData(FALSE);
      reader_status = CLOSED;

      OnOpen();
    }

    /* Stop here */
    return;
  }
}
